# $PROJET/stddef.tcl
# Projet:	Designer de grilles d'ecran.
# Description de fonctions utilitaires diverses.
# 4Js-PM
# Derniere modif : 27.04.1995
# -----------------------------------------------------------------------

global _STDDEF
set _STDDEF "OK"

global setTrace
set setTrace 0

proc call {obj meth args} {
	global $obj
upvar $obj ob
#	uplevel [ eval [eval set ${obj}(meth,$meth)] $args ]
	uplevel "[eval set ob(meth,$meth)] $args" 
}

proc notrace { args } {
}

proc trace { args } {
	global setTrace
	if { $setTrace > 0} {
	   puts $args
	   }
}

proc tell { obj } {
	global $obj
	puts "root   of $obj is [set ${obj}(root)]"
	puts "widget of $obj is [set ${obj}(widget)]"
	puts "name   of $obj is [set ${obj}(name)]"
	foreach entity [array names $obj] {
		puts "$entity	of $obj	is	[set ${obj}($entity)]"
		}
	}

proc whatin { obj {file "whatin"} } {
	global $obj
	set qq [open $file w]
	foreach tagada [array names $obj] {
		puts $qq "${obj}($tagada)	is equal	>[set ${obj}($tagada)]<"

		}
	}

# -----------------------------------------------------------------------
# Definition of classes, is like definition of a procedure

proc CLASS	args { uplevel proc $args }

# -----------------------------------------------------------------------
# A methode is a fonction attached to a class

proc METHODE    args { uplevel proc $args }

# -----------------------------------------------------------------------
# descending is used when a class definition is heriting from a father

proc DESCENDING	args { uplevel $args }

# -----------------------------------------------------------------------
# This function is used during developping time.

proc Dummy { {name "Unknown widget"} }  {
puts "call of $name"
}




